MCP Tools Reference: capacityplanner.googleapis.com

Tool: query_reservations

Returns Compute Engine reservation data (allocations and future reservations) in a project, folder, or organization, either as aggregated reserved and used time series or as per-reservation details. Use this tool to compare reserved capacity with actual usage or to list reservations. Requires parent (for example, 'projects/{project}/locations/{location}', 'folders/{folder}/locations/{location}', or 'organizations/{organization}/locations/{location}'), cloudResourceType, reservationType, and reservationDataLevel.

The following code sample shows how to use curl to call the query_reservations MCP tool.

Curl Request
curl --location 'https://capacityplanner.googleapis.com/mcp' \
--header 'content-type: application/json' \
--header 'accept: application/json, text/event-stream' \
--data '{
  "method": "tools/call",
  "params": {
    "name": "query_reservations",
    "arguments": {
      // Provide these details according to the MCP tool specification.
    }
  },
  "jsonrpc": "2.0",
  "id": 1
}'

Input Schema

The QueryReservations request.

QueryReservationsRequest

JSON representation
{
  "parent": string,
  "locationLevel": enum (LocationType),
  "machineFamily": string,
  "machineShape": {
    object (MachineShape)
  },
  "gpuType": string,
  "cloudResourceType": string,
  "reservationType": enum (ReservationType),
  "shareType": enum (ShareType),
  "ownershipType": enum (OwnershipType),
  "reservationDataLevel": enum (ReservationDataLevel),
  "includeUnapprovedReservations": boolean,
  "aggregationMethod": enum (AggregationMethod),
  "startDate": {
    object (Date)
  },
  "endDate": {
    object (Date)
  }
}
Fields
parent

string

Required. The project, folder, or organization and location for the time series values to return. The format is:

projects/{project}/locations/{location} or organizations/{organization}/locations/{location} or folders/{folder}/locations/{location}

locationLevel

enum (LocationType)

Optional. The location level of the reservations usage timeseries.

machineFamily

string

Optional. The machine family to use to select the aggregate reserved values to return. Possible values include "n1", and "n2d" etc. Empty machine_family will return results matching all machine families.

machineShape

object (MachineShape)

Optional. The machine_shape as a filter to select matching reservations.

gpuType

string

Optional. The GPU type for the reserved values to return. Sample values are "nvidia-tesla-t4", and "nvidia-tesla-a100". See https://cloud.google.com/compute/docs/gpus for a list. Empty gpu_type will return results matching all GPUs.

cloudResourceType

string

Required. The resource for the reserved values to return. Possible values include "gce-vcpus", "gce-ram", "gce-local-ssd", "gce-gpu" and "gce-vm".

reservationType

enum (ReservationType)

Required. The type of reservations to return: allocations, future reservations, or both. Use RESERVATION_TYPE_ALL to include both types. RESERVATION_TYPE_UNSPECIFIED is rejected.

shareType

enum (ShareType)

Optional. Types of share settings to filter reservations in response. If unspecified, all types are included.

ownershipType

enum (OwnershipType)

Optional. Types of ownerships to filter reservations based on. In case of OWNED, it filters reservations which are owned by selected parent project/folder/organization. If unspecified, all types are included.

reservationDataLevel

enum (ReservationDataLevel)

Required. Reservations output data format.

includeUnapprovedReservations

boolean

Optional. Whether to include pending for approval reservations in the response. This field is only applicable for future reservations.

aggregationMethod

enum (AggregationMethod)

Optional. The aggregation method of the historical reservation usage. Must be unspecified when reservation_type is RESERVATION_TYPE_FUTURE_RESERVATION.

startDate

object (Date)

Optional. The start date of reservations usage. If specified, end_date must also be specified. Don't specify a date range when you query current allocations (RESERVATION_TYPE_ALLOCATION without aggregation_method).

endDate

object (Date)

Optional. The end date of reservations usage. If specified, start_date must also be specified.

MachineShape

JSON representation
{
  "machineFamily": string,
  "machineType": string,
  "machineShape": string,
  "cpuCores": number,
  "gpuType": string,
  "gpuComputeType": string,
  "gpuCores": string,
  "localSsdPartitions": string,
  "localSsdGb": number,
  "memoryGb": number,
  "localSsdInterface": string,
  "minCpuPlatform": string
}
Fields
machineFamily

string

Optional. The VM family.

machineType

string

Optional. The characteristics of the sampled VM expressed as a string.

machineShape

string

Optional. The customer visible string representing the type of VM.

cpuCores

number

Optional. Number of CPU cores per VM.

gpuType

string

Optional. The type of GPU with the VM.

gpuComputeType

string

Optional. The GPU name recognized by Compute Engine APIs.

gpuCores

string (int64 format)

Optional. The number of GPU cores per VM.

localSsdPartitions

string (int64 format)

Optional. The number of local SSD partitions per VM.

localSsdGb

number

Optional. Total amount of local SSD storage.

memoryGb

number

Optional. Total amount of memory with the VM.

localSsdInterface

string

Optional. The local SSD interface used such as nvme or scsi

minCpuPlatform

string

Optional. The minimum CPU platform used, such as icelake.

Date

JSON representation
{
  "year": integer,
  "month": integer,
  "day": integer
}
Fields
year

integer

Year of the date. Must be from 1 to 9999, or 0 to specify a date without a year.

month

integer

Month of a year. Must be from 1 to 12, or 0 to specify a year without a month and day.

day

integer

Day of a month. Must be from 1 to 31 and valid for the year and month, or 0 to specify a year by itself or a year and month where the day isn't significant.

LocationType

The type of location that the time series is summarizing.

Enums
LOCATION_TYPE_UNSPECIFIED No location type was specified.
REGIONAL Time series values represent usage aggregated at the region level.
ZONAL Time series values represent usage aggregated at the zone level.

ReservationType

Type of the reservation

Enums
RESERVATION_TYPE_UNSPECIFIED No reservation type specified.
RESERVATION_TYPE_ALLOCATION Allocation refers to realized reservation either auto created or created by the users on demand.
RESERVATION_TYPE_FUTURE_RESERVATION Future Reservation requests created by users.
RESERVATION_TYPE_ALL All reservations.

ShareType

Possible scope in which the reservation can be shared.

Enums
SHARE_TYPE_UNSPECIFIED No share type specified.
SHARE_TYPE_LOCAL Default value, for which reservation is open to only owner project.
SHARE_TYPE_SPECIFIC_PROJECTS Shared-reservation is open to specific projects.

OwnershipType

Reservation ownership status to provide distinction for Capacity Planning.

Enums
OWNERSHIP_TYPE_UNSPECIFIED No ownership status specified.
OWNERSHIP_TYPE_OWNED Reservations owned by the selected Google Cloud resource container (project, folder, or organization).
OWNERSHIP_TYPE_SHARED_BY_OTHERS Reservations that the selected Google Cloud resource container (project, folder, or organization) can consume, but doesn't own.

ReservationDataLevel

The form in which data of reservations should be returned. In case of AGGREGATED, timeseries for selected reservations is returned. If unspecified, all levels are included.

Enums
RESERVATION_DATA_LEVEL_UNSPECIFIED No reservation data level specified.
RESERVATION_DATA_LEVEL_AGGREGATED Aggregated reservations data as a time series, or as an aggregation over a time series.
RESERVATION_DATA_LEVEL_PER_RESERVATION Per-reservation details for each future reservation or allocation, limited to the fields that are relevant for capacity planning.

AggregationMethod

Methods for converting sampled data to time series values.

Enums
AGGREGATION_METHOD_UNSPECIFIED No aggregation method is specified.
MEDIAN Deprecated: Use P50 instead.
PEAK Deprecated: Use P99 instead.
P50 Time series values represent the 50th(median) percentile of the sampled values.
P75 Time series values represent the 75th percentile of the sampled values.
P99 Time series values represent the 99th percentile of the sampled values.
P100 Time series values represent the max of the sampled values.

Output Schema

The QueryReservations response.

QueryReservationsResponse

JSON representation
{
  "reservations": [
    {
      object (ReservationData)
    }
  ]
}
Fields
reservations[]

object (ReservationData)

The reservations data that match the request.

ReservationData

JSON representation
{
  "name": string,
  "timeSeries": {
    object (TimeSeries)
  },
  "usedReservationValues": {
    object (TimeSeries)
  },
  "futureReservations": [
    {
      object (FutureReservation)
    }
  ],
  "allocations": [
    {
      object (Allocation)
    }
  ]
}
Fields
name

string

Identifier. The resource name of the reservation in the form of: projects/{project_id}/locations/{location_id}/reservations/{reservation_id} or organizations/{organization_id}/locations/{location_id}/reservations/{reservation_id} or folders/{folder_id}/locations/{location_id}/reservations/{reservation_id}

timeSeries

object (TimeSeries)

The collection of data points that represent the aggregated reserved value for reservations filtered by the criteria.

usedReservationValues

object (TimeSeries)

The collection of data points that represent the aggregated used value for reservations filtered by the criteria.

futureReservations[]

object (FutureReservation)

Future reservations filtered by the criteria.

allocations[]

object (Allocation)

Allocations filtered by the criteria.

TimeSeries

JSON representation
{
  "locationType": enum (LocationType),
  "location": string,
  "isSpot": boolean,
  "machineFamily": string,
  "diskType": string,
  "confidentialMode": boolean,
  "gpuType": string,
  "tpuType": string,
  "machineShape": {
    object (MachineShape)
  },
  "gcsBucketTraffic": {
    object (GcsBucketTraffic)
  },
  "cloudResourceType": string,
  "points": [
    {
      object (Point)
    }
  ],
  "unit": string
}
Fields
locationType

enum (LocationType)

Required. The type of location that the time series is summarizing.

location

string

Optional. The location of the usage data in time series.

isSpot

boolean

Optional. Whether the time series represents usage of Spot (preemptible) resources.

machineFamily

string

The machine family for the time series values to return. Possible values include "n1" and "n2d".

diskType

string

The disk type for the time series values to return.

confidentialMode

boolean

Optional. The confidential mode for disk.

gpuType

string

The GPU type of the time series.

tpuType

string

The TPU type of the time series.

machineShape

object (MachineShape)

The machine shape of the time series.

gcsBucketTraffic

object (GcsBucketTraffic)

Output only. The Cloud Storage bucket traffic resource for usage time series.

cloudResourceType

string

The resource for the time series values to return. Possible values include "gce-vcpus", "gce-ram", "gce-local-ssd", "gce-persistent-disk", "gce-gpu", "gce-tpu" and "gce-vm".

points[]

object (Point)

The data points of this time series. When listing time series, points are returned in chronological order.

unit

string

The units in which the values are reported.

MachineShape

JSON representation
{
  "machineFamily": string,
  "machineType": string,
  "machineShape": string,
  "cpuCores": number,
  "gpuType": string,
  "gpuComputeType": string,
  "gpuCores": string,
  "localSsdPartitions": string,
  "localSsdGb": number,
  "memoryGb": number,
  "localSsdInterface": string,
  "minCpuPlatform": string
}
Fields
machineFamily

string

Optional. The VM family.

machineType

string

Optional. The characteristics of the sampled VM expressed as a string.

machineShape

string

Optional. The customer visible string representing the type of VM.

cpuCores

number

Optional. Number of CPU cores per VM.

gpuType

string

Optional. The type of GPU with the VM.

gpuComputeType

string

Optional. The GPU name recognized by Compute Engine APIs.

gpuCores

string (int64 format)

Optional. The number of GPU cores per VM.

localSsdPartitions

string (int64 format)

Optional. The number of local SSD partitions per VM.

localSsdGb

number

Optional. Total amount of local SSD storage.

memoryGb

number

Optional. Total amount of memory with the VM.

localSsdInterface

string

Optional. The local SSD interface used such as nvme or scsi

minCpuPlatform

string

Optional. The minimum CPU platform used, such as icelake.

GcsBucketTraffic

JSON representation
{
  "trafficPath": enum (TrafficPath),
  "bucketLocationType": enum (LocationType),
  "bucketLocation": string
}
Fields
trafficPath

enum (TrafficPath)

Optional. Path type for the Cloud Storage bucket traffic.

bucketLocationType

enum (LocationType)

Optional. Location type of the Cloud Storage bucket.

bucketLocation

string

Optional. Location of the Cloud Storage bucket e.g. us-central1 (single region), us (multi region) and eur4 - europe-north1 and europe-west4 (dual region).

Point

JSON representation
{
  "eventTime": string,
  "value": number
}
Fields
eventTime

string (Timestamp format)

The time which the data point applies.

Uses RFC 3339, where generated output will always be Z-normalized and use 0, 3, 6 or 9 fractional digits. Offsets other than "Z" are also accepted. Examples: "2014-10-02T15:01:23Z", "2014-10-02T15:01:23.045123456Z" or "2014-10-02T15:01:23+05:30".

value

number

The value of the data point.

Timestamp

JSON representation
{
  "seconds": string,
  "nanos": integer
}
Fields
seconds

string (int64 format)

Represents seconds of UTC time since Unix epoch 1970-01-01T00:00:00Z. Must be between -62135596800 and 253402300799 inclusive (which corresponds to 0001-01-01T00:00:00Z to 9999-12-31T23:59:59Z).

nanos

integer

Non-negative fractions of a second at nanosecond resolution. This field is the nanosecond portion of the duration, not an alternative to seconds. Negative second values with fractions must still have non-negative nanos values that count forward in time. Must be between 0 and 999,999,999 inclusive.

FutureReservation

JSON representation
{
  "id": string,
  "createTime": string,
  "zone": string,
  "description": string,
  "futureReservation": string,
  "ownerProjectId": string,
  "timeWindow": {
    object (TimeWindow)
  },
  "shareSettings": {
    object (ShareSettings)
  },
  "namePrefix": string,
  "status": {
    object (Status)
  },
  "autoCreatedReservationsDeleteTime": string,
  "autoDeleteAutoCreatedReservations": boolean,

  // Union field type can be only one of the following:
  "specificSkuProperties": {
    object (SpecificSKUProperties)
  }
  // End of list of possible types for union field type.
}
Fields
id

string (int64 format)

A unique identifier for this future reservation. The server defines this identifier.

createTime

string (Timestamp format)

The creation timestamp for this future reservation.

Uses RFC 3339, where generated output will always be Z-normalized and use 0, 3, 6 or 9 fractional digits. Offsets other than "Z" are also accepted. Examples: "2014-10-02T15:01:23Z", "2014-10-02T15:01:23.045123456Z" or "2014-10-02T15:01:23+05:30".

zone

string

URL of the Zone where this future reservation resides.

description

string

Description of the future reservation provided by user.

futureReservation

string

The future reservation resource name.

ownerProjectId

string

timeWindow

object (TimeWindow)

Time window for this Future Reservation.

shareSettings

object (ShareSettings)

List of Projects/Folders to share with.

namePrefix

string

Name prefix for the reservations to be created at the time of delivery. The name prefix must comply with RFC1035. Maximum allowed length for name prefix is 20. Automatically created reservations name format will be NAME_PREFIX-date-####.

status

object (Status)

Status of the Future Reservation

autoCreatedReservationsDeleteTime

string (Timestamp format)

Future timestamp when the reservations that were automatically created by the future reservation will be deleted by Compute Engine. Format of this field must be a valid RFC3339 value.

Uses RFC 3339, where generated output will always be Z-normalized and use 0, 3, 6 or 9 fractional digits. Offsets other than "Z" are also accepted. Examples: "2014-10-02T15:01:23Z", "2014-10-02T15:01:23.045123456Z" or "2014-10-02T15:01:23+05:30".

autoDeleteAutoCreatedReservations

boolean

Setting for enabling or disabling automatic deletion for auto-created reservation. If set to true, auto-created reservations will be deleted at Future Reservation's end time (default) or at user's defined timestamp if any of the [auto_created_reservations_delete_time, auto_created_reservations_duration] values is specified. For keeping auto-created reservation indefinitely, this value should be set to false.

Union field type. The type of the future reservation which can only be for a specific SKU for now. type can be only one of the following:
specificSkuProperties

object (SpecificSKUProperties)

Future Reservation configuration to indicate instance properties and total count.

SpecificSKUProperties

JSON representation
{
  "instanceProperties": {
    object (AllocatedInstanceProperties)
  },
  "totalCount": string
}
Fields
instanceProperties

object (AllocatedInstanceProperties)

Properties of the SKU instances being reserved.

totalCount

string (int64 format)

Total number of instances for which capacity assurance is requested at a future time period.

AllocatedInstanceProperties

JSON representation
{
  "machineType": string,
  "guestAccelerator": [
    {
      object (AcceleratorConfig)
    }
  ],
  "minCpuPlatform": string,
  "localSsd": [
    {
      object (AllocatedDisk)
    }
  ]
}
Fields
machineType

string

Specifies type of machine (name only) which has fixed number of vCPUs and fixed amount of memory. This also includes specifying custom machine type following custom-NUMBER_OF_CPUS-AMOUNT_OF_MEMORY pattern.

guestAccelerator[]

object (AcceleratorConfig)

Specifies accelerator type and count.

minCpuPlatform

string

Minimum CPU platform for the reservation.

localSsd[]

object (AllocatedDisk)

Specifies amount of local ssd to reserve with each instance. The type of disk is local-ssd.

AcceleratorConfig

JSON representation
{
  "type": string,
  "count": integer
}
Fields
type

string

Accelerator name. See https://cloud.google.com/compute/docs/gpus/#introduction for a full list of accelerator types.

count

integer

The number of the guest accelerator cards exposed to this instance.

AllocatedDisk

JSON representation
{
  "diskSizeGb": string,
  "diskInterface": enum (DiskInterface)
}
Fields
diskSizeGb

string (int64 format)

Specifies the size of the disk in base-2 GB.

diskInterface

enum (DiskInterface)

Specifies the disk interface to use for attaching this disk, which is either SCSI or NVME. The default is SCSI.

TimeWindow

JSON representation
{
  "startTime": string,
  "endTime": string
}
Fields
startTime

string (Timestamp format)

Start time of the Future Reservation.

Uses RFC 3339, where generated output will always be Z-normalized and use 0, 3, 6 or 9 fractional digits. Offsets other than "Z" are also accepted. Examples: "2014-10-02T15:01:23Z", "2014-10-02T15:01:23.045123456Z" or "2014-10-02T15:01:23+05:30".

endTime

string (Timestamp format)

End time of the Future Reservation.

Uses RFC 3339, where generated output will always be Z-normalized and use 0, 3, 6 or 9 fractional digits. Offsets other than "Z" are also accepted. Examples: "2014-10-02T15:01:23Z", "2014-10-02T15:01:23.045123456Z" or "2014-10-02T15:01:23+05:30".

ShareSettings

JSON representation
{
  "shareType": enum (ShareType),
  "projects": [
    string
  ]
}
Fields
shareType

enum (ShareType)

Type of sharing for this shared-reservation

projects[]

string

A List of Project names to specify consumer projects for this shared-reservation. This is only valid when share_type's value is SPECIFIC_PROJECTS.

Status

JSON representation
{
  "procurementStatus": enum (ProcurementStatus),
  "lockTime": string,
  "autoCreatedReservations": [
    string
  ],
  "fulfilledCount": string
}
Fields
procurementStatus

enum (ProcurementStatus)

Current state of this Future Reservation

lockTime

string (Timestamp format)

Time when Future Reservation would become LOCKED, after which no modifications to Future Reservation will be allowed. Applicable only after the Future Reservation is in the APPROVED state. The lock_time is an RFC3339 string. The procurement_status will transition to PROCURING state at this time.

Uses RFC 3339, where generated output will always be Z-normalized and use 0, 3, 6 or 9 fractional digits. Offsets other than "Z" are also accepted. Examples: "2014-10-02T15:01:23Z", "2014-10-02T15:01:23.045123456Z" or "2014-10-02T15:01:23+05:30".

autoCreatedReservations[]

string

Fully qualified urls of the automatically created reservations at start_time.

fulfilledCount

string (int64 format)

This count indicates the fulfilled capacity so far. This is set during "PROVISIONING" state. This count also includes capacity delivered as part of existing matching reservations.

Allocation

JSON representation
{
  "id": string,
  "createTime": string,
  "zone": string,
  "description": string,
  "allocation": string,
  "ownerProjectId": string,
  "status": enum (Status),
  "shareSettings": {
    object (ShareSettings)
  },
  "autoDeleteTime": string,

  // Union field type can be only one of the following:
  "specificAllocation": {
    object (SpecificSKUAllocation)
  }
  // End of list of possible types for union field type.
}
Fields
id

string (int64 format)

The unique identifier for the resource. This identifier is defined by the server.

createTime

string (Timestamp format)

The creation timestamp for this allocation.

Uses RFC 3339, where generated output will always be Z-normalized and use 0, 3, 6 or 9 fractional digits. Offsets other than "Z" are also accepted. Examples: "2014-10-02T15:01:23Z", "2014-10-02T15:01:23.045123456Z" or "2014-10-02T15:01:23+05:30".

zone

string

Zone in which the reservation resides.

description

string

A description while creating reservation.

allocation

string

The reservation resource name.

ownerProjectId

string

status

enum (Status)

The status of the reservation.

shareSettings

object (ShareSettings)

Specify share-settings to create a shared reservation.

autoDeleteTime

string (Timestamp format)

Absolute time in future when the reservation will be auto-deleted by Compute Engine.

Uses RFC 3339, where generated output will always be Z-normalized and use 0, 3, 6 or 9 fractional digits. Offsets other than "Z" are also accepted. Examples: "2014-10-02T15:01:23Z", "2014-10-02T15:01:23.045123456Z" or "2014-10-02T15:01:23+05:30".

Union field type. The type of the reservation which can only be for a specific SKU for now. type can be only one of the following:
specificAllocation

object (SpecificSKUAllocation)

Reservation for instances with specific machine shapes.

SpecificSKUAllocation

JSON representation
{
  "instanceProperties": {
    object (AllocatedInstanceProperties)
  },
  "count": string,
  "usedCount": string,
  "assuredCount": string
}
Fields
instanceProperties

object (AllocatedInstanceProperties)

The instance properties for the reservation.

count

string (int64 format)

Specifies the number of resources that are allocated.

usedCount

string (int64 format)

Indicates how many instances are in use.

assuredCount

string (int64 format)

Indicates how many instances are actually usable currently.

LocationType

The type of location that the time series is summarizing.

Enums
LOCATION_TYPE_UNSPECIFIED No location type was specified.
REGIONAL Time series values represent usage aggregated at the region level.
ZONAL Time series values represent usage aggregated at the zone level.

TrafficPath

Path type for the Cloud Storage bucket traffic.

Enums
TRAFFIC_PATH_UNSPECIFIED Unspecified traffic path.
TRAFFIC_PATH_GOOGLE Traffic path through Google's network.
TRAFFIC_PATH_INTERNET Traffic path through the internet.

LocationType

Location type/level of the Cloud Storage bucket.

Enums
LOCATION_TYPE_UNSPECIFIED Unspecified location type.
LOCATION_TYPE_SINGLE_REGION Single region location type.
LOCATION_TYPE_DUAL_REGION Dual region location type.
LOCATION_TYPE_MULTI_REGION Multi region location type.

DiskInterface

guest device interface options to use for the disk.

Enums
DISK_INTERFACE_UNSPECIFIED Default value. This value is unused.
SCSI SCSI disk interface.
NVME NVME disk interface.
NVDIMM NVDIMM disk interface.
ISCSI ISCSI disk interface.

ShareType

Possible scope in which the reservation can be shared.

Enums
SHARE_TYPE_UNSPECIFIED Default value. This value is unused.
ORGANIZATION Shared-reservation is open to entire Organization
SPECIFIC_PROJECTS Shared-reservation is open to specific projects
LOCAL Default value.
DIRECT_PROJECTS_UNDER_SPECIFIC_FOLDERS Shared-reservation is open to direct child projects of specific folders.

ProcurementStatus

Represents procurement status of the Future Reservation.

Enums
PROCUREMENT_STATUS_UNSPECIFIED This is unused status value.
PENDING_APPROVAL Future reservation is pending approval by Google Cloud.
APPROVED Future reservation is approved by Google Cloud.
COMMITTED Future reservation is committed by the customer.
DECLINED Future reservation is rejected by Google Cloud.
CANCELLED Future reservation is cancelled by the customer.
PROCURING Future reservation is being procured by Google Cloud. Beyond this point, Future reservation is locked and no further modifications are allowed.
PROVISIONING Future reservation capacity is being provisioned. This state will be entered after start_time, while reservations are being created to provide total_count reserved instance slots. This state will not persist past start_time + 24h.
FULFILLED Future reservation is fulfilled completely.
FAILED Future reservation failed. No additional reservations were provided.
FAILED_PARTIALLY_FULFILLED Future reservation is partially fulfilled. Additional reservations were provided but did not reach total_count reserved instance slots.
DRAFTING Future reservation is a draft that hasn't been submitted yet. Transitions to PENDING_APPROVAL when the user submits the future reservation.
PENDING_AMENDMENT_APPROVAL An Amendment to the Future Reservation has been requested. If the Amendment is declined, the Future Reservation will be restored to the last known good state.

Status

The status of the reservation.

Enums
STATUS_UNSPECIFIED Default value. This value is unused.
INVALID Invalid Reservation
CREATING Resources are being allocated for the reservation.
READY Reservation has allocated all its resources.
DELETING Reservation is currently being deleted.
UPDATING Reservation is currently being resized.

Tool Annotations

Tool annotations are sent to MCP clients to describe the basic risk of a given tool. Most clients treat these hints as untrusted, but they can be used to decide when a confirmation prompt might be sent to a user.

Along with the title string, the following boolean hints are defined as follows:

  • readOnlyHint: If true, the tool doesn't modify its environment. Default: false.
  • destructiveHint: If true, then the tool can perform destructive actions. If false, then the tool can only perform additive actions. Default: true.
  • idempotentHint: If true, then calling the tool repeatedly with the same arguments will have no additional effect on its environment. Default: false.
  • openWorldHint: If true, then the tool can interact with an 'open world' of external entities. If false, then the tool can only interact with internal entities. For example, a web search tool would be open world, while a memory tool would not be open world.

Destructive Hint: ❌ | Idempotent Hint: ✅ | Read Only Hint: ✅ | Open World Hint: ❌